var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { memo, useContext, useMemo } from 'react';
import Box from '@mui/material/Box';
import classnames from 'classnames';
import { evaluateDeepEntityLabel, getAttributeTypeSubAttributes, getHistoryAppearanceByUri, getHistoryAttributeClassName, getLabel } from '@reltio/mdm-sdk';
import { HistoryDiffContext } from '../contexts/HistoryAppearanceContext';
import { ReadOnlyComplexAttribute } from '../ReadOnlyComplexAttribute';
import { PivotingTooltip } from '../PivotingTooltip';
import { SearchHighlighter } from '../SearchHighlighter';
import { useStyles } from './styles';
var NestedAttribute = function (_a) {
    var attributeValue = _a.attributeValue, attributeType = _a.attributeType, otherProps = __rest(_a, ["attributeValue", "attributeType"]);
    var styles = useStyles();
    var appearance = useContext(HistoryDiffContext).appearance;
    var attributeLabel = useMemo(function () {
        var attributeAppearance = getHistoryAppearanceByUri(attributeValue.uri, appearance);
        var historyAttributesClassName = getHistoryAttributeClassName(attributeAppearance);
        var label = attributeValue.label
            ? attributeValue.label
            : evaluateDeepEntityLabel(attributeValue, attributeType.dataLabelPattern);
        return (React.createElement(PivotingTooltip, { className: styles.pivotingTooltip, value: attributeValue, attributeType: attributeType },
            React.createElement(Box, { component: "span", className: classnames(styles[historyAttributesClassName], styles.label) },
                React.createElement(SearchHighlighter, { text: getLabel(label) }))));
    }, [appearance, styles, attributeValue, attributeType]);
    return (React.createElement(ReadOnlyComplexAttribute, __assign({ label: attributeLabel, attributeValue: attributeValue, attributeTypesList: getAttributeTypeSubAttributes({}, attributeType), attributeType: attributeType }, otherProps)));
};
export default memo(NestedAttribute);
